#!/usr/bin/env python

import mdk_check_update_common

import pygtk
pygtk.require('2.0')

import gtk
import gnome.applet
import gnome.ui

import bonobo
echo_obj = bonobo.get_object ('OAFIID:Bonobo_Sample_Echo', 'Bonobo/Sample/Echo')

pix_uptodate = None
pix_obsolete = None
status_img = None

first_timer = None
label = None

def force_gtk_refresh():
	while gtk.events_pending():
		gtk.mainiteration()

def about_cb(widget, data):
	about = gnome.ui.About("mdk-check-update", mdk_check_update_common.version, "(C) 2003 Olivier Blin", "Applet to notify updates of urpmi media.", ["Olivier Blin"], [])
	about.show()

def update_menu(applet):
	menu = """
<popup name="button3">"""

	medium_index = 0
	uptodate_media = 0
	obsolete_media = 0
	for medium in mdk_check_update_common.media:
		if medium['type'] in ['ftp']:
			if 'update_available' in medium:
				icon_type = "pixbuf"
				icon_name = bonobo.ui.ui_util_pixbuf_to_xml(pix_obsolete)
				obsolete_media += 1
			elif not 'error' in medium:
				icon_type = "pixbuf"
				icon_name = bonobo.ui.ui_util_pixbuf_to_xml(pix_uptodate)
				uptodate_media += 1
			else:
				icon_type = "stock"
				icon_name = "gtk-dialog-error"
		else:
			icon_type = "stock"
			icon_name = "gtk-dialog-error"

		menu = menu + """
    <menuitem name=\"Item """ + str(medium_index) + """\" verb=\"Networks\" label=\"""" + medium['name'] + """\" pixtype=\"""" + icon_type + """\" pixname=\"""" + icon_name + """\"/>"""
		medium_index += 1
	menu = menu + """
    <menuitem name=\"Item """ + str(medium_index) + """\" verb=\"About\" label=\"About...\" pixtype=\"stock\" pixname=\"gnome-stock-about\"/>
</popup>
"""

	if obsolete_media > 0:
		status_img.set_from_pixbuf(pix_obsolete)
	elif uptodate_media > 0:
		status_img.set_from_pixbuf(pix_uptodate)
	else:
		status_img.set_from_stock("gtk-dialog-error", gtk.ICON_SIZE_LARGE_TOOLBAR)

	applet.setup_menu(menu,
			  [ ("About", about_cb) ],
			  None)

def update_status(applet):
	label.set_text("Checking")
	force_gtk_refresh()
	echo_obj.echo("Read config")
	mdk_check_update_common.read_config()
	echo_obj.echo("Check media")
	mdk_check_update_common.check_media()
	echo_obj.echo("Update menu")
	update_menu(applet)
	echo_obj.echo("Update done")
	label.set_text("")
	force_gtk_refresh()
	return gtk.TRUE

def first_status_update(applet):
	global first_timer
	update_status(applet)
	gtk.timeout_remove(first_timer)
	gtk.timeout_add(mdk_check_update_common.update_interval*1000, update_status, applet)

def init_pixbufs():
	global pix_uptodate, pix_obsolete
	pix_uptodate = gtk.gdk.pixbuf_new_from_file(mdk_check_update_common.icon_uptodate)
	pix_obsolete = gtk.gdk.pixbuf_new_from_file(mdk_check_update_common.icon_obsolete)

def mdk_check_update_factory(applet, iid):
	global first_timer, label, status_img
	echo_obj.echo("Init")
	label = gtk.Label("Init")
	init_pixbufs()
	status_img = gtk.Image()
	h = gtk.HBox()
	h.pack_start(status_img)
	h.pack_start(label)
	applet.add(h)
	applet.show_all()
	echo_obj.echo("Init Menu")
	update_menu(applet)
	first_timer = gtk.timeout_add(mdk_check_update_common.first_update*1000, first_status_update, applet)
	return gtk.TRUE

echo_obj.echo("Lauching the beast")
gnome.applet.bonobo_factory("OAFIID:GNOME_MdkCheckUpdate_Factory", 
			    gnome.applet.Applet.__gtype__, 
			    "Mdk-check-update", "0", mdk_check_update_factory)
